
%We use the output of boyer implementaion: reverse DFI order, edge
%ordering, cut vertices where components are merged
clear all;
[VRvertexOrder, vertexNum, edge_size, adjList, inputPos, edgeOrder, max_deg] = create_input;

% Create the base grid for output
aa = length(VRvertexOrder);
% choose a and b based on the input graph
a = max(inputPos(:,1))+30;
b = max(inputPos(:,2))+30;
[targetGrid, grid_coord, grid_xy] = create_grid(a,b);
outputGrid = sparse(a*b,a*b);
% gplot(targetGrid, grid_coord, 'y');
%Now we define a struct of vertices which keeps the ordered list of
%neighbors for each vertex
maxVertices = struct('nIndex',[]);

%First, we fill in the neighbor indices of this struct, based on the input
%order. (To be filled, using the output of boyer implementation)
tempIndex = 0;
for i = 1:length(adjList)
    if tempIndex ~= adjList(i,2)
        j = 1;
        tempIndex = adjList(i,2);
        if tempIndex ~= adjList(i,1)
             maxVertices(tempIndex).nIndex(j) = adjList(i,1);
             j = j+1;
        end
    else
        if tempIndex ~= adjList(i,1)
             maxVertices(tempIndex).nIndex(j) = adjList(i,1);
             j = j+1;
        end
        
    end
end

% make structures
vertexList = Vertex.empty;
for i = 1:length(VRvertexOrder)
    vertexList(i) = Vertex(VRvertexOrder(i));
    tempAdjList = union(maxVertices(VRvertexOrder(i)).nIndex,VRvertexOrder(i));
    tempSorted = intersect(VRvertexOrder,tempAdjList,'stable');
    selfIndex = find(tempSorted == VRvertexOrder(i));
    invertedLowNeiList = tempSorted(1:selfIndex - 1);
    vertexList(i).lowNeiList = invertedLowNeiList(end:-1:1);
    vertexList(i).highNeiList = tempSorted(selfIndex + 1:length(tempSorted));
    tempV = vertexList(i).vIndex;
   
end

%Before starting to place the vertices, we need to define two entities
%which will help us with the implementation of the second phase. The first
%entity is the "pointPermit" sparse matrix, which holds for each point in
%the grid, the list of possible vertices that can use it as their arm
%joints(either all of them, or at most two). The Second one is
%"verToCanMap", which provides us with a mapping from vertex
%indices(vIndex) to the index in the canonical ordering or in the
%"vertexList".

pointPermit = sparse(a*b, length(vertexList));
verToCanMap = zeros(length(vertexList),1);
for i = 1:length(vertexList)
    verToCanMap(vertexList(i).vIndex) = i;
end

%At this stage of the algorithm we must place the vertices and make 
% the side edges of the vertices unavailable.
vpointList = zeros(1,length(vertexList));
for i = 1:length(vertexList)
    vertexList(i).position(1) = inputPos(VRvertexOrder(i),1);
    vertexList(i).position(2) = inputPos(VRvertexOrder(i),2);
    vPnt = (a * vertexList(i).position(2)) + vertexList(i).position(1) + 1;
    targetGrid(vPnt,vPnt + a) = 0;
    targetGrid(vPnt + a,vPnt) = 0;
    if (vPnt - a > 0)
        targetGrid(vPnt,vPnt - a) = 0;
        targetGrid(vPnt - a,vPnt) = 0;
    end
    vpointList(i) = posToPoint(vertexList(i).position(1), vertexList(i).position(2), a);
end

% gplot(targetGrid, grid_coord, 'y');

%Connecting vertices to their bottom neighbors, based on the labels.
for i = 2:length(vertexList)
    if i == 15
        true;
    end
    fprintf('iteration = %d\n',i);
    vIndex = vertexList(i).vIndex;
    vCanIndex = i;
    
    for j = 1:size(vertexList(i).lowNeiList,1)
            
            wIndex = vertexList(i).lowNeiList(j);
            wCanIndex = verToCanMap(wIndex);
            % change -1 to +1 ???!!!!
            % all edges come out from left
            p1 = posToPoint(vertexList(i).position(1) - 1, vertexList(i).position(2), a);
            [pointPermit, vertexList] = editLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            p2 = posToPoint(vertexList(wCanIndex).position(1) - 1, vertexList(wCanIndex).position(2), a);
            [pointPermit, vertexList] = editLabel(p2, vIndex, wIndex, pointPermit, vertexList, verToCanMap);

            
            %Now the algorithm dictates that we make the available points 
            %of each of the two vertices available in the targetGrid. Then
            %for now, we decide to make the available points of all other            
            %vertices unavailable. This is not an efficient approach, but
            %in the final implementation A* can be modified in a way that            
            %only finds a path through vertices with certain labels.
            % changed "makeAvailable" function to a new function 
            % "makeAvailableList" func   ####JAN 22
            for k = 1:length(vertexList(vCanIndex).avaiPointList)
                targetGrid = makeAvailable(vertexList(vCanIndex).avaiPointList(k), targetGrid, a);
            end
%             targetGrid = makeAvailableList(vertexList(vCanIndex).avaiPointList, targetGrid, a, vpointList);
            for k = 1:length(vertexList(wCanIndex).avaiPointList)
                targetGrid = makeAvailable(vertexList(wCanIndex).avaiPointList(k), targetGrid, a);
            end
%             targetGrid = makeAvailableList(vertexList(wCanIndex).avaiPointList, targetGrid, a, vpointList);
            for k = 1:length(vertexList)
                if k ~= vCanIndex && k ~= wCanIndex
                    for kk = 1:length(vertexList(k).avaiPointList)
                        if pointPermit(vertexList(k).avaiPointList(kk),vIndex) == 0 && ...
                                pointPermit(vertexList(k).avaiPointList(kk),wIndex) == 0
                            targetGrid = makeUnavailable(vertexList(k).avaiPointList(kk), targetGrid, a);
                        end
                    end
                  
                end
            end
            %Now we need to find the shortest path between v(the vertex
            %being processed) and w(the neighbor), using A-Star
            start = posToPoint(vertexList(vCanIndex).position(1), vertexList(vCanIndex).position(2), a);
%             setAstarStart(vertexList, a, vCanIndex,targetGrid);
            % set the goal to be the neighbor itself or a vertex in its
            % available points####JAN 25
            goal = posToPoint(vertexList(wCanIndex).position(1), vertexList(wCanIndex).position(2), a);
%             setAstarGoal(vertexList, a, wCanIndex,targetGrid);
            % Use the euclidean distance to the goal as the heuristic
            h = @(u) abs(grid_xy(u,1) - grid_xy(goal,1))+ abs(grid_xy(u,2) - grid_xy(goal,2));
            % Setup a routine to stop when we find the goal
            ev = @(u) (u ~= goal);
            
            if length(targetGrid)>10e4
                % create a temporary box for A-star
                v = [vertexList(vCanIndex).position(1), vertexList(vCanIndex).position(2)];
                w = [vertexList(wCanIndex).position(1), vertexList(wCanIndex).position(2)];
                targetGrid = boxForAstar(targetGrid,grid_coord, a,start,goal,v,w);
                [~, pred, ~] = astar_search(targetGrid, start, h, struct('visitor', struct('examine_vertex', ev)));
            else
                [~, pred, ~] = astar_search(targetGrid, start, h, struct('visitor', struct('examine_vertex', ev)));
            end
            
            g = goal;
            while (true)
                gb = pred(g);
                outputGrid = addEdge(outputGrid, g, gb);
              %  edgeList{vIndex,1,1} = addEdge(edgeList{vIndex,1,1},g,gb);
                if gb == start
                    break
                end
                [pointPermit, vertexList] = editLabel(gb, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
                g = gb;
            end
            
            %Now it is time to make the available points of both v and w,
            %unavailable.
            for k = 1:length(vertexList(vCanIndex).avaiPointList)
                targetGrid = makeUnavailable(vertexList(vCanIndex).avaiPointList(k), targetGrid, a);
            end
            for k = 1:length(vertexList(wCanIndex).avaiPointList)
                targetGrid = makeUnavailable(vertexList(wCanIndex).avaiPointList(k), targetGrid, a);
            end
        
    end
end





