% run with post processing 
clear all;
[VRvertexOrder, vertexNum, edge_size, adjList, inputPos, edgeOrder, max_deg] = create_input;
% Create the base grid for output
% choose a and b based on the input graph
a = max(inputPos(:,1))+30;
b = max(inputPos(:,2))+10;
[targetGrid, grid_coord, grid_xy] = create_grid(a,b);
outputGrid = sparse(a*b,a*b);
emodels = cell(vertexNum,1);
maxVertices = struct('nIndex',[]);
tempIndex = 0;
for i = 1:length(adjList)
    if tempIndex ~= adjList(i,2)
        j = 1;
        tempIndex = adjList(i,2);
        if tempIndex ~= adjList(i,1)
             maxVertices(tempIndex).nIndex(j) = adjList(i,1);
             j = j+1;
        end
    else
        if tempIndex ~= adjList(i,1)
             maxVertices(tempIndex).nIndex(j) = adjList(i,1);
             j = j+1;
        end
        
    end
end
% make structures
vertexList = Vertex.empty;
for i = 1:length(VRvertexOrder)
    vertexList(i) = Vertex(VRvertexOrder(i));
    tempAdjList = union(maxVertices(VRvertexOrder(i)).nIndex,VRvertexOrder(i));
    tempSorted = intersect(VRvertexOrder,tempAdjList,'stable');
    selfIndex = find(tempSorted == VRvertexOrder(i));
    invertedLowNeiList = tempSorted(1:selfIndex - 1);
    vertexList(i).lowNeiList = invertedLowNeiList(end:-1:1);
    vertexList(i).highNeiList = tempSorted(selfIndex + 1:length(tempSorted));
    tempV = vertexList(i).vIndex;
   
end
pointPermit = sparse(a*b, length(vertexList));
verToCanMap = zeros(length(vertexList),1);
for i = 1:length(vertexList)
    verToCanMap(vertexList(i).vIndex) = i;
end
vpointList = zeros(1,length(vertexList));
for i = 1:length(vertexList)
    vertexList(i).position(1) = inputPos(VRvertexOrder(i),1);
    vertexList(i).position(2) = inputPos(VRvertexOrder(i),2);
    vPnt = (a * vertexList(i).position(2)) + vertexList(i).position(1) + 1;
    targetGrid(vPnt,vPnt + a) = 0;
    targetGrid(vPnt + a,vPnt) = 0;
    if (vPnt - a > 0)
        targetGrid(vPnt,vPnt - a) = 0;
        targetGrid(vPnt - a,vPnt) = 0;
    end
    vpointList(i) = posToPoint(vertexList(i).position(1), vertexList(i).position(2), a);
    pointPermit(vPnt,vertexList(i).vIndex) = 1;
end

% run
exflag = VRepWeighted(outputGrid, targetGrid, pointPermit, vertexList, verToCanMap, ...
    emodels, vpointList, grid_xy, grid_coord, max_deg,a); 
count =1;
while ~exflag
    for i=2:length(vertexList)
        vertexList(i).position(1) = vertexList(i).position(1)+(i-1);
    end
    clear targetGrid outputGrid pointPermit
    a = a+length(vertexList);
%     b = b+length(vertexList);
    [targetGrid, grid_coord, grid_xy] = create_grid(a,b);
    outputGrid = sparse(a*b,a*b);
    pointPermit = sparse(a*b, length(vertexList));
    for i = 1:length(vertexList)
%         vertexList(i).position(1) = inputPos(VRvertexOrder(i),1);
%         vertexList(i).position(2) = inputPos(VRvertexOrder(i),2);
        vPnt = (a * vertexList(i).position(2)) + vertexList(i).position(1) + 1;
        targetGrid(vPnt,vPnt + a) = 0;
        targetGrid(vPnt + a,vPnt) = 0;
        if (vPnt - a > 0)
            targetGrid(vPnt,vPnt - a) = 0;
            targetGrid(vPnt - a,vPnt) = 0;
        end
        vpointList(i) = posToPoint(vertexList(i).position(1), vertexList(i).position(2), a);
        pointPermit(vPnt,vertexList(i).vIndex) = 1;
    end
    exflag = VRepWeighted(outputGrid, targetGrid, pointPermit, vertexList, verToCanMap, ...
    emodels, vpointList, grid_xy, grid_coord, max_deg,a); 
    count = count+1;
end








