clear all;
[outputGrid, targetGrid, pointPermit, vertexList, verToCanMap, ...
    vmodels, vpointList, grid_xy, grid_coord, max_deg,a] = initialize;
figure;
gplot(targetGrid, grid_coord, 'y');
firstPath = zeros(1,length(grid_coord));

%Connecting vertices to their bottom neighbors, based on the labels.
for i = 2:length(vertexList)
    if i == 8
        true;
    end
    fprintf('iteration = %d\n',i);
    vIndex = vertexList(i).vIndex;
    vCanIndex = i;
    hold on
    plot(vertexList(i).position(1), vertexList(i).position(2), '*')
    hold on;
    gplot(outputGrid,grid_coord,'r');
    hold on
    gplot(targetGrid, grid_coord, 'c');
    criticalP = [vpointList(i)-1, vpointList(i)-a, vpointList(i)-1-a];
    for j = 1:size(vertexList(i).lowNeiList,1)
            
            wIndex = vertexList(i).lowNeiList(j);
            wCanIndex = verToCanMap(wIndex);
            % change -1 to +1 ???!!!!
            % all edges come out from left
            p1 = posToPoint(vertexList(i).position(1) - 1, vertexList(i).position(2), a);
            [pointPermit, vertexList] = editLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            p2 = posToPoint(vertexList(wCanIndex).position(1) - 1, vertexList(wCanIndex).position(2), a);
            [pointPermit, vertexList] = editLabel(p2, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            % here +1
            p1 = posToPoint(vertexList(i).position(1)+1, vertexList(i).position(2), a);
            [pointPermit, vertexList] = editLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            p2 = posToPoint(vertexList(wCanIndex).position(1)+ 1, vertexList(wCanIndex).position(2), a);
            [pointPermit, vertexList] = editLabel(p2, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
            
            %Now the algorithm dictates that we make the available points 
            %of each of the two vertices available in the targetGrid. Then
            %for now, we decide to make the available points of all other            
            %vertices unavailable. This is not an efficient approach, but
            %in the final implementation A* can be modified in a way that            
            %only finds a path through vertices with certain labels.
            % changed "makeAvailable" function to a new function 
            % "makeAvailableList" func   ####JAN 22
            for k = 1:length(vertexList(vCanIndex).avaiPointList)
                targetGrid = makeAvailable(vertexList(vCanIndex).avaiPointList(k), targetGrid, a);
%                 gplot(targetGrid,grid_coord,'g');
            end
%             targetGrid = makeAvailableList(vertexList(vCanIndex).avaiPointList, targetGrid, a, vpointList);
            for k = 1:length(vertexList(wCanIndex).avaiPointList)
                targetGrid = makeAvailable(vertexList(wCanIndex).avaiPointList(k), targetGrid, a);
%                 gplot(targetGrid,grid_coord,'g');
            end
%             targetGrid = makeAvailableList(vertexList(wCanIndex).avaiPointList, targetGrid, a, vpointList);
            for k = 1:length(vertexList)
                if k ~= vCanIndex && k ~= wCanIndex
                    for kk = 1:length(vertexList(k).avaiPointList)
                        if pointPermit(vertexList(k).avaiPointList(kk),vIndex) == 0 && ...
                                pointPermit(vertexList(k).avaiPointList(kk),wIndex) == 0
                            targetGrid = makeUnavailable(vertexList(k).avaiPointList(kk), targetGrid, a);
                        end
                    end
                  
                end
            end
            targetGrid = makeUnavailableList(vertexList, targetGrid, a, vCanIndex, wCanIndex);
            %Now we need to find the shortest path between v(the vertex
            %being processed) and w(the neighbor), using A-Star
            start = posToPoint(vertexList(vCanIndex).position(1), vertexList(vCanIndex).position(2), a);
%             setAstarStart(vertexList, a, vCanIndex,targetGrid);
            % set the goal to be the neighbor itself or a vertex in its
            % available points####JAN 25
            goal = posToPoint(vertexList(wCanIndex).position(1), vertexList(wCanIndex).position(2), a);
%             setAstarGoal(vertexList, a, wCanIndex,targetGrid);
            % Use the manhattan distance to the goal as the heuristic
%             h = @(u) abs(grid_xy(u,1) - grid_xy(goal,1))+ abs(grid_xy(u,2) - grid_xy(goal,2));
            h = @(u) sqrt((grid_xy(u,1) - grid_xy(goal,1))^2+(grid_xy(u,2) - grid_xy(goal,2))^2);
            % Setup a routine to stop when we find the goal
            ev = @(u) (u ~= goal);
            
            if length(targetGrid)>10e4
                % create a temporary box for A-star
                v = [vertexList(vCanIndex).position(1), vertexList(vCanIndex).position(2)];
                w = [vertexList(wCanIndex).position(1), vertexList(wCanIndex).position(2)];
                targetGrid = boxForAstar(targetGrid,grid_coord, a,start,goal,v,w);
                [~, pred, ~] = astar_search(targetGrid, start, h, struct('visitor', struct('examine_vertex', ev)));
            else
                [~, pred, ~] = astar_search(targetGrid, start, h, struct('visitor', struct('examine_vertex', ev)));
            end
            
            if (size(vertexList(i).lowNeiList,1)>1) 
                if (j==1)   
                    firstPath = pred;   
                elseif (j>1) && ~isempty(find(vertexList(i).avaiPointList==criticalP(1), 1)) ...
                    && ~isempty(find(vertexList(i).avaiPointList==criticalP(2), 1))...
                    && ~isempty(find(vertexList(i).avaiPointList==criticalP(3),1))
                    pred(vpointList(i)-1-a: vpointList(i)-a) = firstPath(vpointList(i)-1-a: vpointList(i)-a);
                end
            end
            
            g = goal;
            while (true)
                gb = pred(g);
                outputGrid = addEdge(outputGrid, g, gb);
                vmodels{i,1} = addEdge(vmodels{i,1}, g, gb);
                if gb == start
                    break
                end
                [pointPermit, vertexList] = editLabel(gb, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
                g = gb;
            end
            
            %Now it is time to make the available points of both v and w,
            %unavailable.
            for k = 1:length(vertexList(vCanIndex).avaiPointList)
                targetGrid = makeUnavailable(vertexList(vCanIndex).avaiPointList(k), targetGrid, a);
            end
            for k = 1:length(vertexList(wCanIndex).avaiPointList)
                targetGrid = makeUnavailable(vertexList(wCanIndex).avaiPointList(k), targetGrid, a);
            end
            
    end
    firstPath =0;
    p1 = posToPoint(vertexList(i).position(1)+1, vertexList(i).position(2), a);
    if isempty(find(vertexList(i).avaiPointList == (p1+1),1))
        [pointPermit, vertexList] = removeLabel(p1, vIndex, wIndex, pointPermit, vertexList, verToCanMap);
    end
end

% plot(vertexList(i).position(1), vertexList(i).position(2), '*')
    hold on;
    gplot(outputGrid,grid_coord,'r');
    hold on
    gplot(targetGrid, grid_coord, 'c');



