function [ VRvertexOrder, vertexNum, edge_size, adj_list, input_coord, inputEdgeOrder, max_deg] = create_input
% adjMatInput: sparse matrix of size a*b


%Reading the output file of Boyer: number of vertices plus edge ordering
addr = '/Users/Ehsan2/Documents/fromBoyerImp/24/testembed.txt';
% 
[inputEdgeOrder, vertexNum, adjMatInput] = getEdgeOrder(addr);

% getting the vertices positions from VR
vrAddr = '/Users/Ehsan2/Documents/fromBoyerImp/24/testVisRep.txt';
visRepPos = getVertexPos(vrAddr,vertexNum);

% Getting the vertex order of VR - sort based on Y-coordinates
temp = sortrows(visRepPos,3);
% sorted from smallest y to largest - meaning from bottom to top in the
% grid
VRvertexOrder = temp(:,1);
% now sorted from bottom to top on the grid - min Y to max
%VRvertexOrder = flipud(VRvertexOrder);

% temp is sorted visRepPos
nx = visRepPos(:,2);
ny = visRepPos(:,3);
input_coord = [nx,ny];
% computing adjacent lists for input graph which means
% finding non-zeros values (the third value are 1's)
[xx, yy, ~] = find(adjMatInput);
edge_size = size(xx); 
adj_list = [xx, yy];
% finding the maximum degree
degree = sum(adjMatInput);
max_deg = max(degree);

end