function outputG = dfsLabel( inputG )
%This Function accepts a graph (Sparse matrix) as input and outputs a new graph which is
%exactly similar to the input graph, except for the fact that the label on
%each vertex has been replaced by the discovery time of that vertex in a
%depth first search, started from the first vertex.

[~, dRes, ~, ~] = dfs(inputG, 1); 
outputG = sparse(size(inputG,1), size(inputG,2));
[u,v] = find(inputG);

for i = 1:length(u)
    outputG = addEdge(outputG, dRes(u(i)), dRes(v(i)));
end

end

