function [model,shared] = findVModel(vertexList,pointPermit,v,grid_coord,vmodels,a)
% cross referencing between pointpermit and avaipointlist to get the
% permanently owned nodes 
% purpose: constructing the vertex model
tempModel = vmodels{v,1};
temp = vertexList(v).avaiPointList;
permanentList = [];
sharedList = [];
for i=1:length(temp)
    p = temp(i);
    % find: returns indices of nonzero elements
    tempAns = find(pointPermit(p,:));
    if (length(tempAns)==1)
        permanentList(end+1) = p;
%     else
%         sharedList(end+1) = p;
    end
end
vp = posToPoint(vertexList(v).position(1), vertexList(v).position(2), a);
permanentList = [vp, permanentList];
permanentList = sort(permanentList);

% organize and form the vertex model
% vector =[grid_coord(permanentList,1), grid_coord(permanentList,2)];
% remove the shared edges from the model
[r,c,~] = find(tempModel);
if ~isempty(r)
    repIndex = find(r<r(1),1);
    r = r(1:repIndex-1);
    c = c(1:repIndex-1);
end
for j=1:length(r)
    m = r(j);
    n = c(j);
    if (isempty(find(permanentList==m,1))) && (isempty(find(permanentList==n, 1)))
        tempModel(m,n) = 0;
        tempModel(n,m)= 0;
    end
end
% add permanent edges
for i=1:length(permanentList)-1
    tempModel(permanentList(i),permanentList(i+1)) = 1;
    tempModel(permanentList(i+1),permanentList(i)) = 1;
end

% % organize and form the shared nodes
 shared = [grid_coord(sharedList,1), grid_coord(sharedList,2)];


model = tempModel;

end

