function [outputGrid, targetGrid, pointPermit, vertexList, verToCanMap, ...
    vmodels,emodels, vpointList, grid_xy, grid_coord, max_deg,a] = initialize
% vertexList, pointpermit, vertocanmap, vpointlist

%We use the output of boyer implementaion: reverse DFI order, edge
%ordering, cut vertices where components are merged
clear all;
[VRvertexOrder, vertexNum, edge_size, adjList, inputPos, edgeOrder, max_deg] = create_input;


% Create the base grid for output
% aa = length(VRvertexOrder);
% choose a and b based on the input graph
a = max(inputPos(:,1))+30;
b = max(inputPos(:,2))+20;
[targetGrid, grid_coord, grid_xy] = create_grid(a,b);
outputGrid = sparse(a*b,a*b);
vmodels = cell(vertexNum,1);
for i=1:vertexNum
    vmodels{i,1} = sparse(a*b,a*b);
end
emodels = cell(vertexNum,1);
% gplot(targetGrid, grid_coord, 'y');
%Now we define a struct of vertices which keeps the ordered list of
%neighbors for each vertex
maxVertices = struct('nIndex',[]);

%First, we fill in the neighbor indices of this struct, based on the input
%order. (To be filled, using the output of boyer implementation)
tempIndex = 0;
for i = 1:length(adjList)
    if tempIndex ~= adjList(i,2)
        j = 1;
        tempIndex = adjList(i,2);
        if tempIndex ~= adjList(i,1)
             maxVertices(tempIndex).nIndex(j) = adjList(i,1);
             j = j+1;
        end
    else
        if tempIndex ~= adjList(i,1)
             maxVertices(tempIndex).nIndex(j) = adjList(i,1);
             j = j+1;
        end
        
    end
end


% make structures
vertexList = Vertex.empty;
for i = 1:length(VRvertexOrder)
    vertexList(i) = Vertex(VRvertexOrder(i));
    tempAdjList = union(maxVertices(VRvertexOrder(i)).nIndex,VRvertexOrder(i));
    tempSorted = intersect(VRvertexOrder,tempAdjList,'stable');
    selfIndex = find(tempSorted == VRvertexOrder(i));
    invertedLowNeiList = tempSorted(1:selfIndex - 1);
    vertexList(i).lowNeiList = invertedLowNeiList(end:-1:1);
    vertexList(i).highNeiList = tempSorted(selfIndex + 1:length(tempSorted));
    tempV = vertexList(i).vIndex;
   
end

%Before starting to place the vertices, we need to define two entities
%which will help us with the implementation of the second phase. The first
%entity is the "pointPermit" sparse matrix, which holds for each point in
%the grid, the list of possible vertices that can use it as their arm
%joints(either all of them, or at most two). The Second one is
%"verToCanMap", which provides us with a mapping from vertex
%indices(vIndex) to the index in the canonical ordering or in the
%"vertexList".

pointPermit = sparse(a*b, length(vertexList));
verToCanMap = zeros(length(vertexList),1);
for i = 1:length(vertexList)
    verToCanMap(vertexList(i).vIndex) = i;
end


%At this stage of the algorithm we must place the vertices and make 
% the side edges of the vertices unavailable.
vpointList = zeros(1,length(vertexList));
for i = 1:length(vertexList)
    vertexList(i).position(1) = inputPos(VRvertexOrder(i),1);
    vertexList(i).position(2) = inputPos(VRvertexOrder(i),2);
    vPnt = (a * vertexList(i).position(2)) + vertexList(i).position(1) + 1;
    targetGrid(vPnt,vPnt + a) = 0;
    targetGrid(vPnt + a,vPnt) = 0;
    if (vPnt - a > 0)
        targetGrid(vPnt,vPnt - a) = 0;
        targetGrid(vPnt - a,vPnt) = 0;
    end
    vpointList(i) = posToPoint(vertexList(i).position(1), vertexList(i).position(2), a);
    pointPermit(vPnt,vertexList(i).vIndex) = 1;
end


