function failCount = isSerial(graph )
%UNTITLED This Function accepts a graph as input and determines whether all
%vertices of the maximal planar version of the graph, have the previous and
%the next vertex in canonical ordering in their adjacency lists.

inputGraph = graph;
MaxPlanarInp = make_maximal_planar(inputGraph);
[is_planar, ksubgraph, EI]= boyer_myrvold_planarity_test(MaxPlanarInp);
n = size(MaxPlanarInp,1); si = zeros(size(EI.edge_order));
for k=1:n, si(EI.vp(k):EI.vp(k+1)-1)=k; end
T = sparse(si,EI.edge_order,1);
inputOrder = [EI.edge_order,si];
canOrder = planar_canonical_ordering(MaxPlanarInp);

maxVertices = struct('nIndex',[],'label',[]);

%First, we fill in the neighbor indices of this struct, based on the input
%order.
tempIndex = 0;
for i = 1:length(inputOrder)
    if tempIndex ~= inputOrder(i,2)
        tempIndex = inputOrder(i,2);
        maxVertices(tempIndex).nIndex(1) = inputOrder(i,1);
    else
        maxVertices(tempIndex).nIndex(end + 1) = inputOrder(i,1);
    end
end

%Now we want to label the Previous and the Next neighbor of each vertex
%based on the Canonical Ordering
failCount = 0;
for i = 1:length(canOrder)
    result = 0;
    if i == 1
        tempVIndex = canOrder(i);
        tempN = canOrder(i + 1);
        for j = 1:length(maxVertices(tempVIndex).nIndex)
            if maxVertices(tempVIndex).nIndex(j) == tempN
                %maxVertices(tempVIndex).label(j) = 12;
                result = 1;
                break;
            end
        end
    else if i == length(canOrder)
            tempVIndex = canOrder(i);
            tempP = canOrder(i - 1);
            for j = 1:length(maxVertices(tempVIndex).nIndex)
                if maxVertices(tempVIndex).nIndex(j) == tempP
                    %maxVertices(tempVIndex).label(j) = 6;
                    result = 1;
                    break;
                end
            end
        else
            tempVIndex = canOrder(i);
            tempP = canOrder(i - 1);
            tempN = canOrder(i + 1);
            pSw = 0;
            nSw = 0;
            for j = 1:length(maxVertices(tempVIndex).nIndex)
                if maxVertices(tempVIndex).nIndex(j) == tempP
                    %maxVertices(tempVIndex).label(j) = 6;
                    pSw = 1;
                elseif maxVertices(tempVIndex).nIndex(j) == tempN
                    %maxVertices(tempVIndex).label(j) = 12;
                    nSw = 1;
                end
                if pSw == 1 && nSw == 1
                    result = 1;
                    break;
                end
            end
        end
    end
    if result == 0
        failCount = failCount + 1;
    end
end
end

