function [model,shared] = findVModel(vertexList,pointPermit,v,grid_coord)
% cross referencing between pointpermit and avaipointlist to get the
% permanently owned nodes 
% purpose: constructing the vertex model
temp = vertexList(v).avaiPointList;
permanentList = [];
sharedList = [];
for i=1:length(temp)
    p = temp(i);
    % find: returns indices of nonzero elements
    tempAns = find(pointPermit(p,:));
    if (length(tempAns)==1)
        permanentList(end+1) = p;
%     else
%         sharedList(end+1) = p;
    end
end
% organize and form the vertex model
vector =[grid_coord(permanentList,1), grid_coord(permanentList,2)];
% adding the vertex itself to the model where the model length <3
if (size(vector,1) < 3) && ~isempty(vector)
    if (size(vector,1)==1) 
        vector = [vector; vertexList(v).position']; 
    else
        d1 = sqrt(abs(vector(1,1)-vertexList(v).position(1))+abs(vector(1,2)-vertexList(v).position(2)));
%         d2 = sqrt(abs(vector(2,1)-vertexList(v).position(1))+abs(vector(2,2)-vertexList(v).position(2)));
        if (d1==1) 
            vector = [vertexList(v).position'; vector];
        else
            vector = [vector; vertexList(v).position'];
        end
    end

% adding the vertex itself to the model where the model length <3
elseif (length(vector) >= 3) && ~isempty(vector)
    yind = find(vector(:,2) == vertexList(v).position(2));
    if isempty(yind)
        if vertexList(v).position(2) < vector(1,2)
             vector = [vertexList(v).position';vector];
         elseif vertexList(v).position(2) > vector(end,2)
             vector = [vector;vertexList(v).position'];
        end
    elseif (length(yind) >= 1)
%         yind = yind - length(vector);
        maxInd = max(yind);
        vector = [vector(1:maxInd,:);[0 0];vector(maxInd+1:end,:)];
        Xs = vector(yind,:);
        Xs = [Xs;vertexList(v).position'];
        [~,xind] = sort(Xs,1);
        yind = [yind;(maxInd+1)];
        for kk=1:length(xind)
            vector(yind(kk),:) = Xs(xind(kk,1),:);
        end
    end
    
end
% continue
dist = [];
if (length(vector) >= 3)
    n = 1;
    while (n<length(vector))
       if (vector(n,2) ~= vector(n+1,2))
           n = n+1;
       else
           m = n+2;
           count = 1;
           if (n~=1)
               dist(end+1) = sqrt((vector(n,1)-vector(n-1,1))^2+(vector(n,2)-vector(n-1,2))^2);
               dist(end+1) = sqrt((vector(n+1,1)-vector(n-1,1))^2+(vector(n+1,2)-vector(n-1,2))^2);
           end
           while (m<=length(vector)) && (vector(m,2) == vector(n,2))
              
               count = count+1;
               if(n~=1) 
                   dist(end+1) = sqrt((vector(m,1)-vector(n-1,1))^2+(vector(m,2)-vector(n-1,2))^2);
               end
                m = m+1;
           end
           if (n==1)
               if (n+count<length(vector))
                   for j=0:count
                       dist(j+1) = sqrt((vector(n+j,1)-vector(n+count+1,1))^2+(vector(n+j,2)-vector(n+count+1,2))^2);
                   end
               else
                   n=m;
                   break;
               end
           end
           
           if ~isempty(dist); 
           [~,ind] = sort(dist); end
           t = vector(n:n+count,:);
           if (n~=1)
               for i=0:count
                   vector(n+i,:) = t(ind(i+1),:);
               end
           else %if (~isempty(dist))
               for i=0:count
                   vector(n+count-i,:) = t(ind(i+1),:);
               end
           end
           dist =[];    
           n = m;
       end

    end
end

% % organize and form the shared nodes
 shared = [grid_coord(sharedList,1), grid_coord(sharedList,2)];
% dist = [];
% if (length(shared) >= 3)
%     n = 1;
%     while (n<length(shared))
%        if (shared(n,2) ~= shared(n+1,2))
%            n = n+1;
%        else
%            m = n+2;
%            count = 1;
%            if (n~=1)
%                dist(end+1) = sqrt((shared(n,1)-shared(n-1,1))^2+(shared(n,2)-shared(n-1,2))^2);
%                dist(end+1) = sqrt((shared(n+1,1)-shared(n-1,1))^2+(shared(n+1,2)-shared(n-1,2))^2);
%            end
%            while (m<length(shared)) && (shared(m,2) == shared(n,2))
%                m = m+1;
%                count = count+1;
%                if(n~=1) 
%                    dist(end+1) = sqrt((shared(m,1)-shared(n-1,1))^2+(shared(m,2)-shared(n-1,2))^2);
%                end
%            end
%            if ~isempty(dist); [~,ind] = sort(dist); end
%            t = shared(n:n+count,:);
%            if ~isempty(dist)
%                for i=0:count
%                    shared(n+i,:) = t(ind(i+1),:);
%                end
%            else
%                for i=0:count
%                    shared(n+i,:) = t(end-i,:);
%                end
%            end
%            dist =[];    
%            n = m;
%        end
% 
%     end
% end

model = vector;

end

